



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Swift - 邮件发送功能的实现</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Swift - 邮件发送功能的实现</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-22 09:39:03 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>使用MessageUI.framework框架除了可以发送短信，还能发送Email，步骤如下：</p>
<div>（1）首先判断设备是否有发送邮件功能</div>
<div>（2）如果设备允许发送邮件，创建一个MFMailComposeViewController视图控制器，并对其设置邮件标题，正文内容，收件人，附件等。</div>
<div>（3）邮件发送后，会执行回调代理方法，可以获取发送结果（成功，失败或取消）</div>
<div>&nbsp;</div>
<div>效果图如下：</div>
<div><img referrerpolicy="no-referrer"src="http://www.hangge.com/blog_uploads/201507/2015071716211577435.png" /></div>
<div>
</div>
<div>代码如下：</div>
<table>
<tbody>
<tr>
<td>
<div>1</div>
<div>2</div>
<div>3</div>
<div>4</div>
<div>5</div>
<div>6</div>
<div>7</div>
<div>8</div>
<div>9</div>
<div>10</div>
<div>11</div>
<div>12</div>
<div>13</div>
<div>14</div>
<div>15</div>
<div>16</div>
<div>17</div>
<div>18</div>
<div>19</div>
<div>20</div>
<div>21</div>
<div>22</div>
<div>23</div>
<div>24</div>
<div>25</div>
<div>26</div>
<div>27</div>
<div>28</div>
<div>29</div>
<div>30</div>
<div>31</div>
<div>32</div>
<div>33</div>
<div>34</div>
<div>35</div>
<div>36</div>
<div>37</div>
<div>38</div>
<div>39</div>
<div>40</div>
<div>41</div>
<div>42</div>
<div>43</div>
<div>44</div>
<div>45</div>
<div>46</div>
<div>47</div>
<div>48</div>
<div>49</div>
<div>50</div>
<div>51</div>
<div>52</div>
<div>53</div>
<div>54</div>
<div>55</div>
<div>56</div>
<div>57</div>
<div>58</div>
<div>59</div>
<div>60</div>
<div>61</div>
<div>62</div>
</td>
<td>
<div>
<div><code>import</code> <code>UIKit</code></div>
<div><code>import</code> <code>MessageUI</code></div>
<div>&nbsp;</div>
<div><code>class</code> <code>ViewController</code><code>: </code><code>UIViewController</code> <code>,</code><code>UINavigationControllerDelegate</code><code>,</code></div>
<div><code>MFMailComposeViewControllerDelegate</code><code>{</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>override</code> <code>func</code> <code>viewDidLoad() {</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>super</code><code>.viewDidLoad()</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//首先要判断设备具不具备发送邮件功能</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>if</code> <code>MFMailComposeViewController</code><code>.canSendMail(){</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>let</code> <code>controller = </code><code>MFMailComposeViewController</code><code>()</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//设置代理</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>controller.mailComposeDelegate = </code><code>self</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//设置主题</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>controller.setSubject(</code><code>"我是邮件标题"</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//设置收件人</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>controller.setToRecipients([</code><code>"a1@hangge.com"</code><code>,</code><code>"a2@hangge.com"</code><code>])</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//设置抄送人</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>controller.setCcRecipients([</code><code>"b1@hangge.com"</code><code>,</code><code>"b2@hangge.com"</code><code>])</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//设置密送人</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>controller.setBccRecipients([</code><code>"c1@hangge.com"</code><code>,</code><code>"c2@hangge.com"</code><code>])</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//添加图片附件</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code> <code>path = </code><code>NSBundle</code><code>.mainBundle().pathForResource(</code><code>"hangge.png"</code><code>, ofType: </code><code>""</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>var</code> <code>myData = </code><code>NSData</code><code>(contentsOfFile: path!)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>controller.addAttachmentData(myData, mimeType: </code><code>"image/png"</code><code>, fileName: </code><code>"swift.png"</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//设置邮件正文内容（支持html）</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>controller.setMessageBody(</code><code>"我是邮件正文"</code><code>, isHTML: </code><code>false</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//打开界面</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>self</code><code>.presentViewController(controller, animated: </code><code>true</code><code>, completion: </code><code>nil</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code><code>else</code><code>{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>println</code><code>(</code><code>"本设备不能发送邮件"</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>//发送邮件代理方法</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>func</code> <code>mailComposeController(controller: </code><code>MFMailComposeViewController</code><code>!,</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>didFinishWithResult result: </code><code>MFMailComposeResult</code><code>, error: </code><code>NSError</code><code>!) {</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>controller.dismissViewControllerAnimated(</code><code>true</code><code>, completion: </code><code>nil</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>switch</code> <code>result.value{</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>case</code> <code>MFMailComposeResultSent</code><code>.value:</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>println</code><code>(</code><code>"邮件已发送"</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>case</code> <code>MFMailComposeResultCancelled</code><code>.value:</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>println</code><code>(</code><code>"邮件已取消"</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>case</code> <code>MFMailComposeResultSaved</code><code>.value:</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>println</code><code>(</code><code>"邮件已保存"</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>case</code> <code>MFMailComposeResultFailed</code><code>.value:</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>println</code><code>(</code><code>"邮件发送失败"</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>default</code><code>:</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>println</code><code>(</code><code>"邮件没有发送"</code><code>)</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>break</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div>&nbsp;</div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>override</code> <code>func</code> <code>didReceiveMemoryWarning() {</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</code><code>super</code><code>.didReceiveMemoryWarning()</code></div>
<div><code>&nbsp;&nbsp;&nbsp;&nbsp;</code><code>}</code></div>
<div><code>}</code></div>
</div>
</td>
</tr>
</tbody>
</table>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gnle87.html">《Web开发过滤Javascript、HTML的方法》</a>
		</li>
						<li><a href="https://www.batexi.com/a/495xdmz8.html">安全测试 - SQL注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/495gn50q.html">ConcurrentDictionary线程不安全么，你难道没疑惑，你难道弄懂了么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7elj19.html">Android&mdash;判断当前时间段</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m5nnrq.html">NBU7&period;0&period;1迁移C&colon;&bsol;Veritas&bsol;Netbackup&bsol;db到其他盘</a>
		</li>
						<li><a href="https://www.batexi.com/a/xq4rmj58.html">Oracle11G 7个服务说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v71jm8.html">Caused by&colon; java&period;lang&period;NoSuchMethodError&colon; org&period;slf4j&period;impl&period;StaticLoggerBinder&period;getSingleton&lpar;&rpar;Lorg&sol;slf4j&sol;i</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn2rjrq.html">MST&lowbar;prim</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0e30eq.html">&lbrack;51NOD1181&rsqb;质数中的质数（质数筛法）（欧拉筛）</a>
		</li>
						<li><a href="https://www.batexi.com/a/96ollgj9.html">升级NppAstyle中的AstyleLib为最高版本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mnrwxpq.html">转&colon;  解决MSYS2下的中文乱码问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/95x1yw68.html">前端高性能滚动 scroll 及页面渲染优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1x3og8.html">PHP高效的敏感词过滤方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydz2mxq.html">&period;net的WebForm模拟MVC进行模型绑定，让自己少操劳</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4yxy3jq.html">关于App的一些迷思以及一些动画效果开源库的推荐</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1zg5e59.html">BFC &sol; hasLayout</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpo63r9.html">PLSQL 几种游标的用法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzevlw8.html">理解本真的REST架构风格</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zd57e9.html">银河英雄传说&lbrack;NOI2002&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jy5eo8.html">win10 UWP FlipView</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q2jd25l8.html">centos7 在 vmware下的安装与配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/9pdn3zd9.html">HDU p1294 Rooted Trees Problem 解题报告</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojnyy5q.html">工商管理硕士&lpar;MBA&rpar;-北大国际MBA</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zx0de9.html">ASP&period;NET站点安全</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojnoneq.html">Easyui  datagrid 批量编辑和提交</a>
			</li>
						<li><a href="https://www.batexi.com/a/9ge1kv48.html">String &amp;quot&semi;&plus;&amp;quot&semi; 的补充说明---行粒度</a>
			</li>
						<li><a href="https://www.batexi.com/a/950rvev8.html">开发快很重要&mdash;&mdash;如果只看法语或者产品结果C&plus;&plus;似乎很强大，但是参与这个C&plus;&plus;的开发过程，就会感觉到这种痛苦（Google也是这个看法）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1wn6mq.html">HDU 1025 DP &plus; 二分</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlje0v09.html">建立Go工作环境</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjkymk8.html">BNU 26579 Andrew the Ant 【蚂蚁】</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
